#version 430

// Input data

layout( location = 0 ) in vec3 iPosition;
layout( location = 1 ) in vec4 iColor;
layout( location = 2 ) in vec3 iNormal;
layout( location = 3 ) in vec3 iDiffuseSpecularEmissive;
layout( location = 4 ) in vec2 iTexCoord;
layout( location = 5 ) in vec3 iTexIndex;

// Uniform data

layout( location = 0 ) uniform mat4 uProjCameraWorld;
layout( location = 1 ) uniform mat3 uNormalMatrix;


// Output attributes

out vec4 v2fColor;
out vec3 v2fNormal;
out vec3 v2fDiffuseSpecularEmissive;
out vec2 v2fTexCoord;
out vec3 v2fPos;
out vec3 v2fTexIndex;

void main()
{
	// Passthrough properties & normalize normal
	v2fColor = iColor;
	v2fPos = iPosition;
	v2fTexCoord = iTexCoord;
	v2fNormal = normalize(uNormalMatrix * iNormal);
	v2fDiffuseSpecularEmissive = iDiffuseSpecularEmissive;
	v2fTexIndex = iTexIndex;

	// Update position according to camera projection
	gl_Position = uProjCameraWorld * vec4(iPosition, 1.0);
}
